import * as plugins from '../plugins.js';
import * as data from '../data/index.js';
import * as userInterfaces from '../data/user.js';

export interface IReq_GetSecretGroups extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_GetSecretGroups
> {
  method: 'getSecretGroups';
  request: {
    identity: userInterfaces.IIdentity;
  };
  response: {
    secretGroups: data.ISecretGroup[];
  };

}

export interface IReq_GetSecretGroupById extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_GetSecretGroupById
> {
  method: 'getSecretGroupById';
  request: {
    identity: userInterfaces.IIdentity;
    secretGroupId: string;
  };
  response: {
    secretGroup: data.ISecretGroup;
  };

}

export interface IReq_CreateSecretGroup extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_CreateSecretGroup
> {
  method: 'createSecretGroup';
  request: {
    identity: userInterfaces.IIdentity;
    secretGroup: data.ISecretGroup;
  };
  response: {
    resultSecretGroup: data.ISecretGroup;
  };
}

export interface IReq_UpdateSecretGroup extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_UpdateSecretGroup
> {
  method: 'updateSecretGroup';
  request: {
    identity: userInterfaces.IIdentity;
    secretGroup: data.ISecretGroup;
  };
  response: {
    resultSecretGroup: data.ISecretGroup;
  };
}

export interface IReq_DeleteSecretGroupById extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_DeleteSecretGroupById
> {
  method: 'deleteSecretGroupById';
  request: {
    identity: userInterfaces.IIdentity;
    secretGroupId: string;
  };
  response: {
    ok: boolean;
  };
}